(in-package :cl-blas)

(defmacro benchmark-runtime ((iterations) &body body)
  `(let* ((total-time (loop for i from 1 to ,iterations
                            sum (let ((start-time (get-internal-real-time)))
                                  ,@body
                                  (- (get-internal-real-time) start-time)))))
     (float (/ total-time ,iterations 1000000))))

(defun benchmark-gemm (size)
  (let* ((A (make-random-array `(,size ,size)))
         (B (make-random-array `(,size ,size)))
         (C (make-random-array `(,size ,size)))
         (alpha 1.0)
         (beta 1.0))
    (format t "running benchmark-mul~%")
    (benchmark-runtime (5) (gemm A B C alpha beta))))
